
//-------------------------------------------------------------------
//
// TITLE:   Tanks battle simulation / Tutorial
// VERSION: 1.0 - Chapter 1
// AUTHOR:  Avi Chami
// DATE:    11/05/2002
//
//-------------------------------------------------------------------


PROGRAM tankbat1;


// ******************************************************************
//
//  The chapters of the tutorial will show you how to make a simple
//  tank combat simulation, on 2D (top view).
//
//  This tutorial will show you some techniques that can
//  be used later to make an RTS or TBS program
//  (Real Time or Turn Based Strategy)
//  On each chapter of the Tutorial, I will include detailed comments
//  for the added portions of the code.
//
//
//  Hope you will find them helpful
//
//  You can contact me at:
//        chclau@yahoo.com
//
//
//  P.S. - Many thanks to Adherbal for contributing with his graphics
//         to this tutorial
// ******************************************************************


// ******************************************************************
//  On this first chapter, we will only draw 15 tanks, from one of
//  the sides in the combat
// ******************************************************************


//-------------------------------------------------------------------
CONST

  MAX_TANKS   = 90;             // Maximum number of tanks on each side
                                // Defines the size of the array that
                                // contains the IDs of the tank processes


  // Quantity of tanks in each group - Must be < 90
  // As we said - we will only draw 15 on this chapter
  TANK1_NO    = 15;



//-------------------------------------------------------------------
GLOBAL

// Graphics and sound

  fpg_id;                       // Id of the fpg file



// Tanks group info

  tanks1_id[MAX_TANKS];         // Array with the IDs of all the
                                // tanks processes

  tanks1_qtty;                  // Qtty of tanks in group one



// General purpose

  g_ind;                        // General purpose index


BEGIN

//-------------------------------------------------------------------
// Initialize sound, graphics, board
//-------------------------------------------------------------------

    max_process_time = 2000;

    set_mode(m1024x768);        // Sets video mode to 1024x768
                                // Since we are going to draw a lot of
                                // tamks - I chose the biggest resolution

    set_fps(24,0);              // Number of frames per second


// Load graphics file
    fpg_id = load_fpg("mytut\tankbat.fpg");



// Initialize game variables

    tanks1_qtty = TANK1_NO;





//-------------------------------------------------------------------
// Draw all the tanks of the first columns
//
// Each tanks process is called with the same 'x', only the 'y' coordinate
// is incremented fore each tank
// Each tanks consists of two processes - The basis and the turret.
// In this way, the basis and the turret can be moved or rotated
// independently


    FROM g_ind = 1 TO 15;

        tanks1_id[g_ind] = tank1 ( 40, -1 + g_ind * 46);

    END


//-------------------------------------------------------------------
// Main loop
//
//   In the main loop we still do nothing... (only refresh the screen)
//-------------------------------------------------------------------

    LOOP

        FRAME;

    END

END



//-------------------------------------------------------------------
// Process tank1
// Draws the basis of a green tank
//-------------------------------------------------------------------


PROCESS tank1 (x, y)

PRIVATE

BEGIN

    z     = 0;
    graph = 10;

// The turret is called from the tank1 process. So 'turret1' is
// the son, and tank1 is the father process.

    turret1 (x+1, y);

    LOOP
        FRAME;
    END

END


//-------------------------------------------------------------------
// Process turret1
// Draws the turret of a green tank
//-------------------------------------------------------------------


PROCESS turret1 (x, y)

PRIVATE

BEGIN

// The turret has lower 'z' than the tank, so it will be always drawn
// OVER the tank

    z     = -100;
    graph = 12;

    LOOP
        FRAME;
    END

END


